// Generated by CoffeeScript 1.3.3

module.exports = function(serverStatus, message, config) {
  if (config == null) {
    config = {};
  }
  return {
    connect: function() {
      var conn;
      conn = io.connect(config.url, config);
      conn.on('message', function(msg, meta) {
        var content, i, responderId;
        if ((i = msg.indexOf('|')) > 0) {
          responderId = msg.substr(0, i);
          content = msg.substr(i + 1);
          return message.emit(responderId, content, meta);
        } else {
          return console.error('Invalid websocket message received:', msg);
        }
      });
      conn.on('ready', function(cb) {
        return serverStatus.emit('ready');
      });
      conn.on('disconnect', function() {
        return serverStatus.emit('disconnect');
      });
      conn.on('reconnect', function() {
        return serverStatus.emit('reconnect');
      });
      conn.on('connect', function() {
        return serverStatus.emit('connect');
      });
      return function(msg) {
        return conn.send(msg);
      };
    }
  };
};
